;**************************************************************
;***    EMS4E2.ASM                                          ***
;***                                                        ***
;***    function        EMS_Ems.swapPageMap32(              ***
;***                        rest_buffer:    Pointer;        ***
;***                        save_buffer:    Pointer)        ***
;***                        : Boolean;                      ***
;***                                                        ***
;***    Returns 0 for OK status or an error                 ***
;***    code.                                               ***
;***                                                        ***
;***    (Ems Version 3.2)                                   ***
;**************************************************************

        .model  large,pascal   

        include emsdefs.asm 

        extrn   errno:WORD  

;
;   Define entry point
;
        public  EMS_Ems@swapPageMap32

        .code

EMS_Ems@swapPageMap32  proc restore_buff:Far Ptr DWord, save_buff:Far Ptr DWord, self:DWord

        push    ds                      ; Save ds
        push    si                      ; Save si
        push    di                      ; Save di

        lds     si,restore_buff         ; Get map to restore into DS:SI
        les     di,save_buff            ; Get save area address into ES:DI

        mov     ax,SwapPageMap32        ; Call EMS to swap
        int     Ems             

        or      ah,ah                   ; Check for error
        jnz     error

        xor     ax,ax                   ; Return a zero meaning no error

        pop     di                      ; Restore di
        pop     si                      ; Restore si
        pop     ds                      ; Restore ds
        ret                             ; Return to caller

error:
        pop     di                      ; Restore di
        pop     si                      ; Restore si
        pop     ds                      ; Restore ds

        mov     al,ah
        xor     ah,ah                   ; Zero high byte
        mov     errno,ax                ; Save in errno too
        ret                             ; Return to caller

EMS_Ems@swapPageMap32   endp            ; End of procedure

        end                             ; End of source file
